/*
 * $Id: changecolordlg.h,v 1.1.1.1 2000/05/25 06:09:58 hige Exp $
 *
 * Copyright (C) 1999 SUZUKI, Mitsuhiro <hige@higesoft.rim.or.jp>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#include <kdialog.h>
#include "resultview.h"

class KColorButton;

class ChangeColorDlg : public KDialog
{
    Q_OBJECT
public:
    ChangeColorDlg(const KResultPart::ColorAttribute& colorattr,
                   QWidget *parent = 0, const char *name = 0, 
                   WFlags f = 0);
    ~ChangeColorDlg();
    const KResultPart::ColorAttribute&
        getColorAttribute() {return *m_colorattr;}
private slots:
    void setBackgroundColor(const QColor& newcolor)
        {m_colorattr->background = newcolor;}
    void setTextColor(const QColor& newcolor)
        {m_colorattr->text = newcolor;}
    void setLinkColor(const QColor& newcolor)
        {m_colorattr->link = newcolor;}
    void setReturnDefault();
private:
    KResultPart::ColorAttribute*    m_colorattr;
    KColorButton*                   m_btnbackgroundcolor;
    KColorButton*                   m_btntextcolor;
    KColorButton*                   m_btnlinkcolor;
};
