/*
 * $Id: findworddlg.cpp,v 1.2 2000/06/19 06:32:09 hige Exp $
 *
 * Copyright (C) 1999 SUZUKI, Mitsuhiro <hige@higesoft.rim.or.jp>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#include <kapp.h>
#include <klocale.h>

#include <qpushbutton.h>
#include <qgroupbox.h>
#include <qlayout.h>

#include "findworddlg.h"

void KFindWordDlg::doLayout()
{
    QVBoxLayout* total_layout = new QVBoxLayout(this, 10);
    CHECK_PTR(total_layout);
    
    total_layout->addWidget(m_frame);

    QVBoxLayout* gbox_layout = new QVBoxLayout(m_frame, 10, 10);
    CHECK_PTR(gbox_layout);
    
    gbox_layout->addSpacing(m_value->height());
    
    gbox_layout->addWidget(m_value);

    QHBoxLayout* checkbox_layout = new QHBoxLayout(gbox_layout, 10);
    CHECK_PTR(checkbox_layout);
    
    m_sensitive->adjustSize();
    checkbox_layout->addWidget(m_sensitive);
    
    m_backward->adjustSize();
    checkbox_layout->addWidget(m_backward);
    
    QHBoxLayout* button_layout = new QHBoxLayout(total_layout, 5);
    CHECK_PTR(button_layout);
    
    m_ok->adjustSize();
    button_layout->addSpacing(m_ok->width());
    
    button_layout->addWidget(m_ok);

    m_cancel->adjustSize();
    button_layout->addWidget(m_cancel);

    total_layout->activate();
    total_layout->freeze();
}
KFindWordDlg::KFindWordDlg(QWidget *parent, const char *name)
    : QDialog(parent, name, FALSE)
{
    this->setFocusPolicy(QWidget::StrongFocus);
    m_frame = new QGroupBox(i18n("Find"), this, "frame");
    CHECK_PTR(m_frame);
    
    m_value = new QLineEdit(m_frame, "value");
    CHECK_PTR(m_value);
    m_value->setFocus();
    connect(m_value, SIGNAL(returnPressed()), this, SLOT(slotOk()));

    m_sensitive = new QCheckBox(i18n("Case Sensitive"), m_frame, "case");
    CHECK_PTR(m_sensitive);

    m_backward = new QCheckBox(i18n("Find Backwards"), m_frame, "backward");
    CHECK_PTR(m_backward);
        
    m_ok = new QPushButton(i18n("Find"), this, "find");
    CHECK_PTR(m_ok);
    connect(m_ok, SIGNAL(clicked()), this, SLOT(slotOk()));

    m_cancel = new QPushButton(i18n("Done"), this, "cancel");
    CHECK_PTR(m_cancel);
    connect(m_cancel, SIGNAL(clicked()), this, SLOT(slotDone()));

    doLayout();
}
void KFindWordDlg::slotOk()
{
  QString text(m_value->text());

  if (!text.isEmpty())
    emit sigSearch();
}
void KFindWordDlg::resizeEvent(QResizeEvent *)
{
}

#include "findworddlg.moc"
