/*
 * $Id: selectsubbookdlg.cpp,v 1.2 2000/06/19 06:32:09 hige Exp $
 *
 * Copyright (C) 1999 SUZUKI, Mitsuhiro <hige@higesoft.rim.or.jp>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */
#include <kapp.h>
#include <klocale.h>

#include <qdialog.h>
#include <qlayout.h>
#include <qlistbox.h>
#include <qpushbutton.h>
#include <qkeycode.h>
#include <qevent.h>

#include "selectsubbookdlg.h"

SelectSubbookDlg::SelectSubbookDlg(const vector <string>& list,
                                   int select_subbook, 
                                   QWidget *parent, const char *name)
        : QDialog(parent, name, true), m_selected_subbook(0)
{
    // Create Main Layout
    QVBoxLayout* mainlayout = new QVBoxLayout(this, 8, 2);
    CHECK_PTR(mainlayout);
    
    // Create Subbook's ListBox
    m_lb_subbooklist = new QListBox(this, "SubbookList");
    CHECK_PTR(m_lb_subbooklist);

    mainlayout->addWidget(m_lb_subbooklist, 8);
    //m_lb_subbooklist->setGeometry(subbooklist_geometry);
    for (int i = 0; i < (signed)list.size(); i++) {
        m_lb_subbooklist->insertItem(QString::fromLocal8Bit(list[i].c_str()));
    }
    if (select_subbook >= 0) {
        m_lb_subbooklist->setSelected(m_selected_subbook = select_subbook,
                                      true);
    }
    // on single-clicking or using arrow keys 
    connect(m_lb_subbooklist, SIGNAL(highlighted(int)), SLOT(onSelected(int)));
    // on double-clicking or pressing enter keys
    connect(m_lb_subbooklist, SIGNAL(selected(int)), SLOT(accept()));
    m_lb_subbooklist->installEventFilter(this);
    
    mainlayout->addSpacing(10);
    
    // Button Layout
    QHBoxLayout* btnlayout = new QHBoxLayout();
    CHECK_PTR(btnlayout);

    mainlayout->addLayout(btnlayout, 1);
    
    // Create OK Button
    QPushButton* ok = new QPushButton(i18n("OK"), this);
    CHECK_PTR(ok);
    btnlayout->addSpacing(150);
    btnlayout->addWidget(ok);
    
    connect(ok, SIGNAL(clicked()), SLOT(accept()));
    
    // Create Cancel Button
    QPushButton* cancel = new QPushButton(i18n("Cancel"), this);
    CHECK_PTR(cancel);
    btnlayout->addWidget(cancel);
    connect(cancel, SIGNAL(clicked()), SLOT(reject()));
    btnlayout->addSpacing(150);

    mainlayout->activate();
    mainlayout->freeze(450, 300);
    setCaption(i18n("Select a dictionary"));
}
bool SelectSubbookDlg::eventFilter(QObject* obj, QEvent* ev)
{
    if (obj == m_lb_subbooklist) {
        switch (ev->type()) {
        case QEvent::MouseButtonDblClick:
            for (uint i = 0; i < m_lb_subbooklist->count(); i++) {
                if (m_lb_subbooklist->isSelected(i)) {
                    accept();
                    break;
                }
            }
            break;
        default:
            break;
        }
    }
    return false;
}
#include "selectsubbookdlg.moc"
